#!/usr/bin/python
import sys
import os
import datetime


def list2dict(list,lim):
    i=0
    outputdict={}
    for item in list:
        if i==0:
            outputdict[item]=0
        else:
            diff=item-preitem
            if diff<lim:
                outputdict[item]=1
                outputdict[preitem]+=2
            else:
                outputdict[item]=0
        preitem=item
        i+=1
    return outputdict


t0 = datetime.datetime.now()

if len(sys.argv) >= 3 and len(sys.argv) <= 4:
    chr_good_list_filename=sys.argv[1]
    jun_filename=sys.argv[2]
    newjun_filename=jun_filename+".new"
    if len(sys.argv)==4:
        newjun_filename=sys.argv[3]
else:
    print("usage: python neighborfiler.py chr_good_list junction.bed ")
    print("usage: or ./neighborfiler.py chr_good_list junction.bed ")
    sys.exit(1)
lim=80
good_point_set=set([])
chr_good_list_file=open(chr_good_list_filename,'r')
for line in chr_good_list_file:
    segment_good_list=eval(line.strip())
    for read_index in segment_good_list:
        for jun_list in segment_good_list[read_index]:
            if abs(jun_list[2])==3:

                good_point_set.add(jun_list[0])
                good_point_set.add(jun_list[1])
chr_good_list_file.close()

jun_file=open(jun_filename,'r')
for line in jun_file:
    if not line[0:5]=='track':
        line_list=line.strip().split('\t')
        thickness=line_list[10].split(',')
        leftpos=int(line_list[1])+int(thickness[0])
        rightpos=int(line_list[2])-int(thickness[1])
        good_point_set.add(leftpos)
        good_point_set.add(rightpos)
jun_file.close()
good_point_list_sorted=sorted(good_point_set)
diff_dict=list2dict(good_point_list_sorted,lim)


jun_file=open(jun_filename,'r')
newjun_file=open(newjun_filename,'w')
for line in jun_file:
    if line[0:5]=='track':
        newjun_file.write(line)
    else:
        line_list=line.strip().split('\t')
        thickness=line_list[10].split(',')
        leftpos=int(line_list[1])+int(thickness[0])
        rightpos=int(line_list[2])-int(thickness[1])
        depth=int(line_list[3].split('(')[1].split(')')[0])
        if depth==1:
            if diff_dict[leftpos]%2==1  and diff_dict[rightpos]>1:
                newjun_file.write(line)       
        else:
            newjun_file.write(line) 
        
jun_file.close()
newjun_file.close()
delta_t = datetime.datetime.now() - t0
print "\t" +  "-running time: " + str(delta_t)


